// Klasse, die fuer das Speichern der Punkte, Loeschen unwichtiger Punkte und die Darstellung zustaendig ist.

import geomerative.*;

class Text
{
  String myText;        // String Variable, in der der Schriftzug gespeichert wird.
  RGroup myGroup;       // Geomerative Variable zum Erstellen der Punkte des Schriftzuges.
  RPoint[] myPoints;    // Array in dem die Punkte gespeichert werden.
  int x, y;             // Die beiden Variablen x und y sind dazu da, um den Koordinatenursprung fuer processing zu verschieben, damit der Schriftzug auch im angezeigten Fenster ist.
  int saved = 0;        // Variable, in der die Anzahl, der nicht herausgenommenen Punkte gespeichert wird.
  int deleted = 0;      // Variable, in der die Anzahl, der herausgenommenen Punkte gespeichert wird.

  void initiate(String text, int l, int testx, int testy)      // Methode um die wichtigen Variablen der Klasse zu initialisieren und das Punkte Array zu erstellen.
  {
    this.myText = text;                                        // Den Variablen des Objekts werden die uebergebenen Variablen zugeordnet.
    this.x = testx;
    this.y = testy;

    RCommand.setSegmentLength(l);                              // Geomerative Befehle, die die Segmentlaenge, also den Abstend zwischen den Punkten einstellen.
    RCommand.setSegmentator(RCommand.UNIFORMLENGTH);

    if (this.myText.length() > 0)
    {
      this.myGroup = myFont.toGroup(this.myText);              // Hier wird der gespeicherte Schriftzug in die Geomerative Variable myGroup gespeichert, um daraus dann die Punkte in das Array zu speichern.
      this.myPoints = this.myGroup.getPoints();
    }
  }

  void shortenAndOutput()                    // In dieser Methode werden aus dem gespeicherten Array der Punkte, Punkte die auf einer Geraden liegen herausgenommen und die uebrig bleibenden werden ausgegeben und dan den Arduino geschickt.
  {
    Point lastPoint = new Point();           // Objekte der Klasse Point werden fuer den letzten Punkt, den aktuellen Punkt, den naechsten Punkt und den zuletzt gespeicherten bzw. nicht herausgenommenen Punkt erstellt.
    Point currentPoint = new Point();
    Point nextPoint = new Point();
    Point lastSavedPoint = new Point();
    
    float difX, difY, currentDistance;       // Variablen fuer Distanzen und Winkel, mit denen bestimmt wird, ob Punkte auf einer Geraden liegen oder nicht.
    float nextDifX, nextDifY, nextDistance;
    float nextAngle = 0.0;
    float angle = 0.0;
    float lastAngle = 0.0;
    char spray = 78;                        // Variable die angibt ob zwischen zwei Punkten gemalt werden soll oder nicht. 89 in ASCII fuer Y (steht fuer yes). 78 in ASCII fuer N (steht fuer no).
    
    translate(this.x, this.y);              // Mit translate wird der Koordinatenursprung verschoben.

    for (int i = 0; i < this.myPoints.length; i++)                      // for-Schleife mit der das Punkte Array durchlaufen werden soll.
    {
      currentPoint.addData(this.myPoints[i].x, this.myPoints[i].y);     // Der aktuelle Punkt wird aus dem Array gelesen und gespeichert.
      
      if (i != 0 && i != this.myPoints.length - 1)                      // Alle folgenden Ueberpruefungen sollen nicht fuer den ersten und letzten Punkt gemacht werden, da diese auf jeden Fall erhalten bleiben sollen, deshalb diese Ueberpruefung als Erstes.
      {
        lastPoint.addData(this.myPoints[i-1].x, this.myPoints[i-1].y);  // Der letzte Punkt wird aus dem Array gelesen und gespeichert.
        nextPoint.addData(this.myPoints[i+1].x, this.myPoints[i+1].y);  // Der naechste Punkt wird aus dem Array gelesen und gespeichert.

        difX = currentPoint.x - lastPoint.x;                            // Berechnung der Diffenrenzen der x und y Werte zwischen dem letzten Punkt und dem aktuellen, sowie dem aktuellen und dem folgenden.
        difY = currentPoint.y - lastPoint.y;
        nextDifX = nextPoint.x - currentPoint.x;
        nextDifY = nextPoint.y - currentPoint.y;
        currentDistance = sqrt(sq(difX) + sq(difY));                    // Aus den Diffenrenzen dann die Berechnung des jeweiligen Abstandes.
        nextDistance = sqrt(sq(nextDifX) + sq(nextDifY));
        angle = atan2(difY, difX);                                      // Und die Berechnung des jeweiligen Winkels.
        nextAngle = atan2(nextDifY, nextDifX);
        
        if (currentDistance < 19)      // Hier wird ueberprueft, ob die Distanz zwischen dem letztem Punkt und dem aktuellen Punkt einen bestimmten Wert ueberschreitet, wenn ja dann gehoeren die Punkte zu unterschiedlichen Abschnitten.
        {
          spray = 89;                  // 89 in ASCII fuer Y (steht fuer yes).
          if (nextDistance < 19)       // Hier wird ueberprueft, ob die Distanz zwischen dem aktuellen Punkt und dem naechsten Punkt einen bestimmten Wert ueberschreitet, wenn ja bedeutet das, dass der aktuelle Punkt der letzte eines Abschnitts ist.
          {
            if (floatEqual1(currentPoint.x, lastPoint.x) && floatEqual1(currentPoint.x, nextPoint.x))             // Ueberpruefung ob der letzte, der aktuelle und der folgende Punkt auf einer Geraden in x liegen (wenn alle x-Werte gleich sind).
            {
              //System.out.println("Auf einer Geraden in x. CurrentPoint " + currentPoint.x + ", " + currentPoint.y + " geloescht.");
              this.deleted++;
            }
            else if (floatEqual1(currentPoint.y, lastPoint.y) && floatEqual1(currentPoint.y, nextPoint.y))        // Ueberpruefung ob der letzte, der aktuelle und der folgende Punkt auf einer Geraden in y liegen (wenn alle y-Werte gleich sind).
            {
              //System.out.println("Auf einer Geraden in y. CurrentPoint " + currentPoint.x + ", " + currentPoint.y + " geloescht.");
              this.deleted++;
            }
            else if (floatEqual2(angle, lastAngle) && floatEqual2(angle, nextAngle))                              // Ueberpruefung ob der letzte, der aktuelle und der folgende Punkt auf einer Geraden in einem Winkel liegen (wenn alle Winkel gleich sind).
            {
              //System.out.println("Auf einer Geraden im gleichen Winkel. CurrentPoint " + currentPoint.x + ", " + currentPoint.y + " geloescht.");
              this.deleted++;
            }
            else                                                        // Das Folgende wird ausgefuehrt, wenn der letzte Punkt, der aktuelle Punkt und der folgende Punkt weder auf einer Geraden in x, noch in y, noch in einem Winkel liegen.
            {
              output(currentPoint, lastSavedPoint, spray);              // Aufruf der output-Methode, mit Uebergabe von currentPoint, LastSavedPoint, und spray.
              lastSavedPoint.addData(currentPoint.x, currentPoint.y);   // Die Werte von currentPoint werden in lastSavedPoint gespeichert.
              this.saved++;
            }
          }
          else                                                          // Das Folgende wird ausgefuehrt, wenn der aktuelle Punkt der letzte des aktuellen Abschnitts ist, er soll definitiv nicht herausgenommen werden, Ueberpruefungen sind also nicht notwendig.
          {
            output(currentPoint, lastSavedPoint, spray);                // Aufruf der output-Methode, mit Uebergabe von currentPoint, LastSavedPoint, und spray.
            lastSavedPoint.addData(currentPoint.x, currentPoint.y);     // Die Werte von currentPoint werden in lastSavedPoint gespeichert.
            this.saved++;
          }
        }
        else                                                            // Das Folgende wird ausgefuehrt, wenn der letzte und der aktuelle Punkt zu weit voneinander entfernt sind, also zu zwei Abschnitten gehoeren, Ueberpruefungen sind also nicht notwendig.
        {
          spray = 78;                                                   // Es soll nicht gemalt werden, deshalb 78 in ASCII fuer N (steht fuer no).
          output(currentPoint, lastSavedPoint, spray);                  // Aufruf der output-Methode, mit Uebergabe von currentPoint, LastSavedPoint, und spray.
          lastSavedPoint.addData(currentPoint.x, currentPoint.y);       // Die Werte von currentPoint werden in lastSavedPoint gespeichert.
          this.saved++;
        }
      }
      else                                                              // Das Folgende wird beim ersten und letzten Punkt ausgefuehrt. Es sollen keine Ueberpruefungen durchgefuehrt werden, da sie definitiv nicht herausgenommen werden sollen.
      {
        output(currentPoint, lastSavedPoint, spray);                    // Aufruf der output-Methode, mit Uebergabe von currentPoint, LastSavedPoint, und spray.
        lastSavedPoint.addData(currentPoint.x, currentPoint.y);         // Die Werte von currentPoint werden in lastSavedPoint gespeichert.
        this.saved++;
      }

      lastAngle = angle;    // Bei jeden Durchlauf soll der aktuelle Winkel in lastangle gespeichert werden, um ihn beim naechsten Durchlauf zum Vergleich zu verwenden.
      
      if (spray == 78)      // Wenn spray auf No steht soll der letzte Winkel auf 0 gesetzt werden, da der naechste Punkt zu einem anderen Abschnitt gehoert und das Programm.
      {
        lastAngle = 0.0;    // bei zufaellig gleichen Winkeln nicht zu dem SChluss kommt sie waeren auf einer Linie und so der letzte Punkt eines Abschnittes geloescht wird.
      }
    }
  }

  boolean floatEqual1(float f1, float f2)                  // Die Methode floatEqual1 bekommen jeweils zwei float-Werte uebergeben und ueberpruefen, ob diese gleich sind bzw. in einem bestimmten Bereich (die Variable dif) voneinander entfernt liegen.
  {
    float dif = 0.05;                                       // dif ist hier 0.05 da floatEquals1 Koordinaten vergleichen soll und dabei Werte mit einer Abweichungen unter 0.05 hier als gleich angenommen werden koennen.
    if (f1 - f2 <= dif && f1 - f2 >= -dif) return true;    // Die Methode gibt true zurueck, wenn die Werte im hier angewendeten Sinn gleich sind.
    else return false;                                     // Wenn nicht, dann flase.
  }

  boolean floatEqual2(float f1, float f2)                  // Die Methode floatEqual1 bekommen jeweils zwei float-Werte uebergeben und ueberpruefen, ob diese gleich sind bzw. in einem bestimmten Bereich (die Variable dif) voneinander entfernt liegen.
  {
    float dif = 0.0001;                                    // dif ist hier 0.0001 da floatEquals2 Winkel vergleichen soll und dabei Werte mit einer Abweichungen unter 0.0001 hier als gleich angenommen werden koennen.
    if (f1 - f2 <= dif && f1 - f2 >= -dif) return true;    // Die Methode gibt true zurueck, wenn die Werte im hier angewendeten Sinn gleich sind.
    else return false;                                     // Wenn nicht, dann flase.
  }
  
  void output(Point currentPoint, Point lastSavedPoint, char spray)                             // Die Methode bekommt den currentPoint, den lastSavedPoint und spray uebergeben.
  {
    int x = (int) currentPoint.x;
    int y = (int) currentPoint.y;
    int lastX = (int) lastSavedPoint.x;
    int lastY = (int) lastSavedPoint.y;
    int sprayValue = 1;
    if (spray == 78) sprayValue = 0;
    System.out.print("{" + sprayValue + ", " + currentPoint.x/100 + ", " + ((currentPoint.y/100) + 3) + "}, ");   // Zuerst werden die Werte von currentPoint ausgegeben. Hier als float.
    //point(currentPoint.x, currentPoint.y);                                                          // Dann wird der Punkt angezeigt.
    //if ( spray == 89) line(lastSavedPoint.x, lastSavedPoint.y, currentPoint.x, currentPoint.y);     // Und zuletzt falls spray auf Yes steht eine Linie von lastSavedPoint zum currentPoint gemalt.
    //System.out.print("{" + sprayValue + ", " + x + ", " + y + "}, ");                                 // Zuerst werden die Werte von currentPoint ausgegeben und wenn gesprüht werden soll eine 1 sonst eine 0. Hier als integer mit leichten Abweichungen.
    ellipse(x, y, 2, 2);                                                                              // Dann wird der Punkt angezeigt.
    if (spray == 89) line(lastX, lastY, x, y);                                                        // Und zuletzt falls spray auf Yes steht eine Linie von lastSavedPoint zum currentPoint gemalt.
  }
  
  void printNumbers()                                                                                                                  // Ausgabe der Insgesamten, gespeicherten und geloeschten Anzahl von Punkten und Werten.
  {
    System.out.println("Anzahl Punkte insgesamt: " + this.myPoints.length + ". Anzahl Werte insgesamt: " + this.myPoints.length*2);
    System.out.println("Anzahl gespeicherter Punkte: " + this.saved + ". Anzahl gespeicherter Werte: " + this.saved*2);
    System.out.println("Anzahl geloeschter Punkte: " + this.deleted + ". Anzahl geloeschter Werte: " + this.deleted*2);
  }
}